import { jsxs as ee, jsx as A } from "react/jsx-runtime";
import { o as te } from "../../chunks/useMergeRefs.DYDIMIZh.js";
import re, { useState as I, useRef as h, useLayoutEffect as m } from "react";
import { i as se, j as ae } from "../../chunks/index.C_BJG1SJ.js";
import { TEXT_AREA_WRAPPER_CLASSNAME as oe, r as le, TEXT_AREA_CLASSNAME as W, TEXT_AREA_CONTROL_RIGHT_CLASSNAME as ce, TEXT_AREA_HELPER_TEXT_CLASSNAME as ne } from "../../chunks/constants.D-rfPeOH.js";
import f from "clsx";
function ie({
  value: e,
  defaultValue: r,
  finalValue: t,
  onChange: a = () => {
  }
}) {
  const [s, x] = I(
    r !== void 0 ? r : t
  );
  return e !== void 0 ? [e, a, !0] : [s, (c) => {
    x(c), a == null || a(c);
  }, !1];
}
const ue = () => "rounded-md text-base h-20 min-h-[80px] resize-none overflow-hidden px-4 py-7", fe = ({
  mode: e
}) => f({
  "bg-surface-darker text-copy-lighter caret-copy-light": e === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": e === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": e === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": e === "alt-system"
}), de = ({
  focusMode: e,
  error: r
}) => r ? "focus:outline focus:outline-2 focus:outline-focus-error-dark" : f("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), pe = ({
  noBorder: e,
  error: r
}) => f("border-2", {
  "border-border-dark": !e,
  "border-transparent": e,
  "border-border-error-dark": r
}), he = ({
  disabled: e,
  raw: r,
  error: t,
  mode: a
}) => r ? "" : f("absolute cursor-text font-medium", {
  "text-copy-lighter": !t && a === "dark",
  "text-copy-dark": !t && a === "light",
  "text-copy-dark dark:text-copy-lighter": !t && a === "system",
  "text-copy-lighter dark:text-copy-dark": !t && a === "alt-system",
  "cursor-not-allowed opacity-50": e
}), xe = ({
  error: e,
  raw: r,
  mode: t
}) => r ? void 0 : f(ne, "absolute px-2 font-medium", {
  "rounded-md bg-surface-darker text-copy-error-light": e,
  "text-copy-lighter": !e && t === "dark",
  "text-copy-dark": !e && t === "light",
  "text-copy-dark dark:text-copy-lighter": !e && t === "system",
  "text-copy-lighter dark:text-copy-dark": !e && t === "alt-system"
}), ge = ({
  className: e,
  textAreaClassName: r,
  raw: t,
  focusMode: a,
  disabled: s,
  noBorder: x,
  error: l,
  spacing: c,
  mode: n
}) => {
  const g = t ? e : f(
    "relative flex w-full flex-col justify-center",
    oe,
    e,
    le(c)
  ), v = t ? f(r) : f(
    W,
    r,
    ue(),
    fe({ mode: n }),
    de({ focusMode: a, error: l }),
    pe({
      noBorder: x,
      error: l
    }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": s
    }
  ), T = t ? void 0 : "sr-only", E = he({
    disabled: s,
    raw: t,
    error: l,
    mode: n
  }), R = xe({
    error: l,
    raw: t,
    mode: n
  }), i = t ? void 0 : f(ce, "absolute");
  return {
    wrapper: g,
    textArea: v,
    accessibleLabel: T,
    visibleLabel: E,
    helperText: R,
    rightElement: i
  };
}, ye = ({
  scrollHeight: e,
  currentHeight: r,
  currentLabelOffset: t = 0,
  currentHelperTextOffset: a = 0
}) => {
  let l, c;
  if (e > 0 && e !== r) {
    const n = e - r, g = Math.abs(n / 24);
    l = t + -1 * Math.sign(n) * (12 * g), c = a + Math.sign(n) * (12 * g);
  }
  return {
    labelOffset: l,
    helperTextOffset: c,
    scrollHeight: e
  };
}, Ae = re.forwardRef(
  ({
    id: e,
    name: r,
    label: t,
    error: a = !1,
    raw: s = !1,
    className: x,
    textAreaClassName: l,
    mode: c = "system",
    focusMode: n = "system",
    value: g,
    defaultValue: v,
    disabled: T = !1,
    noBorder: E = !1,
    labelId: R,
    helperText: i = "",
    helperTextOnFocus: _ = !1,
    rightElement: L,
    onChange: F,
    onFocus: P,
    onBlur: $,
    spacing: B,
    ...G
  }, V) => {
    const u = h(null), z = te([V, u]), N = h(null), C = h(80), j = h(-25), p = h(null), M = h(30), b = h(null), k = se({ id: e, prefix: `${W}-` }), [D, U] = I(0), [q, X] = I(
      !!(!_ && i)
    ), J = `${r} error, ${i}`, y = ge({
      className: x,
      textAreaClassName: l,
      error: a,
      raw: s,
      focusMode: n,
      disabled: T,
      noBorder: E,
      spacing: B,
      mode: c
    }), [d, K] = ie({
      value: g,
      defaultValue: v,
      onChange: (o) => {
        F && F({
          target: {
            value: o
          }
        });
      }
    }), Q = (o) => {
      K(o.target.value);
    }, Y = (o) => {
      _ && i && X(!0), P && P(o);
    }, Z = (o) => {
      _ && i && !d && X(!1), $ && $(o);
    };
    return m(() => {
      !s && N.current && U(N.current.offsetWidth + 18 + 10);
    }, [s]), m(() => {
      s || u && u.current && d !== void 0 && (u.current.style.height = "inherit", u.current.style.height = u.current.scrollHeight + "px");
    }, [d, s]), m(() => {
      s || setTimeout(() => {
        var o;
        (o = p == null ? void 0 : p.current) == null || o.style.setProperty(
          "--av-text-area-wrapper-transition",
          d ? "none" : "all 0.2s ease-out"
        );
      }, 0);
    }, [d, s]), m(() => {
      var o, O;
      if (!s && u && u.current && d !== void 0) {
        const { labelOffset: S, helperTextOffset: H, scrollHeight: w } = ye({
          scrollHeight: u.current.scrollHeight,
          currentHeight: C.current,
          currentLabelOffset: j.current,
          currentHelperTextOffset: M.current
        });
        S && (j.current = S, (o = p == null ? void 0 : p.current) == null || o.style.setProperty(
          "--av-text-area-label",
          `${S}px`
        )), H && (M.current = H, (O = b == null ? void 0 : b.current) == null || O.style.setProperty(
          "--av-text-area-helper-text",
          `${H}px`
        )), C.current = w || C.current;
      }
    }, [d, s]), /* @__PURE__ */ ee("div", { className: y.wrapper, children: [
      /* @__PURE__ */ A(
        "label",
        {
          htmlFor: k,
          id: R,
          className: y.accessibleLabel,
          children: t
        }
      ),
      /* @__PURE__ */ A(
        "textarea",
        {
          ref: z,
          id: k,
          name: r,
          disabled: T,
          placeholder: s ? void 0 : " ",
          className: y.textArea,
          rows: 1,
          ...i && { "aria-describedby": `${k}-helper` },
          ...a && { "aria-invalid": "true" },
          ...L && !s && { style: { paddingRight: D } },
          value: d,
          onChange: Q,
          onFocus: Y,
          onBlur: Z,
          ...G
        }
      ),
      !s && /* @__PURE__ */ A(
        "label",
        {
          ref: p,
          "aria-hidden": !0,
          htmlFor: k,
          className: y.visibleLabel,
          children: t
        }
      ),
      q && /* @__PURE__ */ A(
        "div",
        {
          ref: b,
          id: `${k}-helper`,
          className: y.helperText,
          children: i
        }
      ),
      L && /* @__PURE__ */ A(
        "div",
        {
          ref: N,
          className: y.rightElement,
          children: L
        }
      ),
      a && i && /* @__PURE__ */ A(ae, { politeness: "polite", clearAnnouncementDelay: 500, children: J })
    ] });
  }
);
Ae.displayName = "TextArea";
export {
  Ae as TextArea
};
